From 97171f7865532c2985804851f7fdec21710fad59 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Aug 25 2017 08:52:48 +0000
Subject: [PATCH 930/1001] Filter out widgets that have been disabled


---

diff --git a/check-cache-coverage.py b/check-cache-coverage.py
index 4e623cc..f79f4c1 100755
--- a/check-cache-coverage.py
+++ b/check-cache-coverage.py
@@ -29,6 +29,8 @@ session = hubs.app.session
 hubs.widgets.registry.register_list(hubs.app.app.config["WIDGETS"])
 
 for w_instance in session.query(hubs.models.Widget).all():
+    if not w_instance.enabled:
+        continue
     for fn_name, fn_class in w_instance.module.get_cached_functions().items():
         if fn_class(w_instance).is_cached():
             full += 1
diff --git a/hubs/backend/triage.py b/hubs/backend/triage.py
index f59769b..b4bb412 100755
--- a/hubs/backend/triage.py
+++ b/hubs/backend/triage.py
@@ -91,6 +91,8 @@ def get_widgets():
     # Get a list of all our widgets:
     log.debug("Querying for all widgets.")
     widgets = session.query(hubs.models.Widget).all()
+    # Filter out widgets that have been disabled.
+    widgets = [w for w in widgets if w.enabled]
     # Randomize so that all the triage daemons work on widgets in different
     # orders.  This should hopefully prevent cache thrashing.
     log.debug("Randomizing list of all widgets.")
diff --git a/hubs/models.py b/hubs/models.py
index f894c22..eebd178 100644
--- a/hubs/models.py
+++ b/hubs/models.py
@@ -456,6 +456,10 @@ class Widget(ObjectAuthzMixin, BASE):
     def edit_url(self):
         return self.module.get_edit_url(self.hub, self)
 
+    @property
+    def enabled(self):
+        return self.plugin in hubs.widgets.registry
+
 
 class User(BASE):
     __tablename__ = 'users'
diff --git a/smart_cache_invalidator.py b/smart_cache_invalidator.py
index 75b4487..b74fdad 100755
--- a/smart_cache_invalidator.py
+++ b/smart_cache_invalidator.py
@@ -27,6 +27,8 @@ hubs.widgets.registry.register_list(hubs.app.app.config["WIDGETS"])
 def do_list(args):
     ''' List the different widget for which there is data cached. '''
     for w_instance in session.query(hubs.models.Widget).all():
+        if not w_instance.enabled:
+            continue
         widget = w_instance.module
         for fn_name, fn_class in widget.get_cached_functions().items():
             if fn_class(w_instance).is_cached():

